#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 64011

typedef struct t_elem
{
	int poz, id[2];
} elem;

void read(void);
void dfs(int nod);
void sort(int r);
int lcp(int i, int j);

int N, *V[MAXN], nrv[MAXN], S[2 * MAXN], A[2 * MAXN], ind, p, B[20][2 * MAXN],
	cnt[2 * MAXN], step, poz[MAXN], nr1[2 * MAXN], nr;
elem P[2 * MAXN], tmp[2 * MAXN];

int main(void)
{
	int i, new_id, len;

	freopen("arbfind.in", "r", stdin);
    freopen("arbfind.out", "w", stdout);

    read();

    for (i = 0; i < ind; i++)
    	cnt[S[i]] = 1;
	for (i = 1; i <= ind; i++)
		cnt[i] += cnt[i - 1];
	for (i = 0; i < ind; i++)
    	B[0][i] = cnt[S[i]];

	nr = 3;
	for (step = 0; 1; step++)
    {
    	for (i = 0; i < ind; i++)
			P[i].poz = i, P[i].id[0] = B[step][i],
            P[i].id[1] = (i + (1 << step) >= ind) ? 0 : B[step][i + (1 << step)];

		sort(1), sort(0);

        for (i = new_id = 0; i < ind; i++)
        {
        	new_id += !i || P[i].id[0] != P[i - 1].id[0] || P[i].id[1] != P[i - 1].id[1];
			B[step + 1][P[i].poz] = new_id;
        }
        if (new_id == ind)
        	break;
		nr = new_id;
    }

	for (i = ind - 1; i > p; i--)
    	poz[A[i]] = i;

	nr1[0] = S[0];
    for (i = 1; i < ind; i++)
    	nr1[i] = nr1[i - 1] + (S[i] == 1);
	for (i = 0; i < N; i++)
    {
    	len = lcp(0, poz[i]);
        printf("%d\n", nr1[len - 1]);
	}

    return 0;
}

void read(void)
{
	int i, j;

	scanf("%d", &N);

    for (i = 0; i < N; i++)
    {
    	scanf("%d", &nrv[i]);
        V[i] = malloc((nrv[i] + 1) * sizeof(int));
        V[i][nrv[i]] = -1;
        for (j = 0; j < nrv[i]; j++)
        	scanf("%d", V[i] + j), V[i][j]--;
    }

	dfs(0);
    p = ind;
    S[ind++] = 2;
    for (i = 0; i < N; i++)
    	free(V[i]);

	scanf("%d", &N);

    for (i = 0; i < N; i++)
    {
    	scanf("%d", &nrv[i]);
        V[i] = malloc((nrv[i] + 1) * sizeof(int));
        V[i][nrv[i]] = -1;
        for (j = 0; j < nrv[i]; j++)
        	scanf("%d", V[i] + j), V[i][j]--;
    }
    dfs(0);
}

void dfs(int nod)
{
	int *k;

    S[ind] = 1, A[ind++] = nod;

    for (k = V[nod]; *k != -1; k++)
    	dfs(*k);

	S[ind] = 0, A[ind++] = nod;
}

void sort(int r)
{
	int i;

    memset(cnt, 0, sizeof(cnt));
    for (i = 0; i < ind; i++)
    	cnt[P[i].id[r]]++;
	for (i = 1; i <= nr; i++)
    	cnt[i] += cnt[i - 1];
	for (i = ind - 1; i >= 0; i--)
    	tmp[--cnt[P[i].id[r]]] = P[i];
	memcpy(P, tmp, ind * sizeof(elem));
}

int lcp(int i, int j)
{
	int step2, rez = 0;

    for (step2 = step; step2 >= 0; step2--)
    	if (i + (1 << step2) <= ind && j + (1 << step2) <= ind && B[step2][i] == B[step2][j])
			rez += 1 << step2, i += 1 << step2, j += 1 << step2;

	return rez;
}
