#include <stdio.h>
#include <string.h>

#define MAXN 512
#define MAXP 64
#define INF 999999999
#define MIN(a, b) ((a) < (b) ? (a) : (b))

void read(void);
void compute_line(int l);
void solve(void);

int P, N, V[MAXN][MAXN], C[MAXN][MAXN], nrv[MAXN], D[MAXP], dist[MAXP][MAXP],
	L[MAXN], seen[MAXN], min[MAXP][MAXP][MAXP];

int main(void)
{
	freopen("team.in", "r", stdin);
    freopen("team.out", "w", stdout);

    memset(V, -1, sizeof(V));

    read();
    solve();

    return 0;
}

void read(void)
{
	int i, m, p, q, c;

	scanf("%d %d %d", &P, &N, &m);

	for (; m; m--)
    {
    	scanf("%d %d %d", &p, &q, &c), p--, q--;
        V[p][nrv[p]] = q, C[p][nrv[p]++] = c;
        V[q][nrv[q]] = p, C[q][nrv[q]++] = c;
    }

    for (i = 1; i <= P; i++)
    	scanf("%d", &D[i]), D[i]--;

   	D[0] = 0, P++;
}

void compute_line(int l)
{
	int i, j, min, p, *k, *c;

    memset(seen, 0, sizeof(seen));
	for (i = 0; i < N; i++)
    	L[i] = INF;

	L[D[l]] = 0;

    for (i = 0; i < N; i++)
    {
    	min = INF;
        for (j = 0; j < N; j++)
        	if (!seen[j] && min > L[j])
            	min = L[j], p = j;
		seen[p] = 1;
        for (k = V[p], c = C[p]; *k != -1; k++, c++)
        	if (L[*k] > L[p] + *c)
            	L[*k] = L[p] + *c;
    }

    for (j = 0; j < P; j++)
    	dist[l][j] = L[D[j]];
}

void solve(void)
{
	int i, j, l, nod, k, s1, s2;

    for (i = 0; i < P; i++)
    	compute_line(i);

 	for (i = 0; i < P; i++)
    	for (j = 0; j < P; j++)
        	min[i][j][j] = dist[i][j];

	for (l = 2; l <= P; l++)
    	for (nod = 0; nod < P; nod++)
        	for (i = 0; i + l - 1 < P; i++)
            {
            	j = i + l - 1;
                min[nod][i][j] = INF;
				for (k = i; k <= j; k++)
                {
                	s1 = k > i ? min[k][i][k - 1] : 0;
                    s2 = k < j ? min[k][k + 1][j] : 0;
                    min[nod][i][j] = MIN(min[nod][i][j], s1 + s2 + dist[nod][k]);
                }
            }

	printf("%d\n", min[0][0][P - 1]);
}
