#include <stdio.h>
#include <stdlib.h>

#define MAX_N 32005
#define BASE 33347
#define MAX_H 666013
#define FIN "arbfind.in"
#define FOUT "arbfind.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define ll long long

int N[2], deg[2][MAX_N], *G[2][MAX_N], H[2][MAX_N], cnt[2][MAX_N], base_pow[MAX_N];

void hash_tree(int t, int n)
{
    register int *p;
    
    for (p = G[t][n]; *p; p++)
    {
        hash_tree(t, *p);
        cnt[t][n] += cnt[t][*p];
        H[t][n] = ((ll) H[t][n] * (ll) base_pow[cnt[t][*p]] + H[t][*p]) % MAX_H;
    }
    H[t][n] = ((ll) H[t][n] + (ll) (deg[t][n]+1) * (ll) base_pow[cnt[t][n]]) % MAX_H;
    cnt[t][n]++;
}

inline int eq(int n1, int n2)
{
    return (H[0][n1] == H[1][n2] && deg[0][n1] == deg[1][n2]) ? cnt[0][n1] : 0;
/*    register int *p, *q, t, ret = 1;

    if (deg[0][n1] != deg[1][n2]) return 0;
    for (p = G[0][n1], q = G[1][n2]; *p && *q; p++, q++)
    {
        if (!(t = eq(*p, *q))) return 0;
        ret += t;
    }
    return ret;*/
}

int DFS(int n1, int n2)
{
    register int *p, *q, t, ret = 1;

    for (p = G[0][n1], q = G[1][n2]; *p && *q; p++, q++)
        if (!(t = eq(*p, *q)))
        {
           ret += DFS(*p, *q);
           break;
        }
        else ret += t;
    return ret;
}

int main(void)
{
    int i, j, t;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    FOR (t, 0, 2)
    {
        scanf("%d", N+t);
        FOR (i, 0, N[t])
        {
            scanf("%d", deg[t]+i);
            G[t][i] = (int *) calloc(deg[t][i]+2, sizeof(int));
            FOR (j, 0, deg[t][i]) { scanf("%d", G[t][i]+j); G[t][i][j]--; }
        }
    }

    base_pow[0] = 1;
    FOR (i, 1, MAX_N) base_pow[i] = ((ll) base_pow[i-1] * (ll) BASE) % MAX_H;
    
    hash_tree(0, 0);
    hash_tree(1, 0);
    FOR (i, 0, N[1]) printf("%d\n", DFS(0, i));
    
    return 0;
}
