#include <stdio.h>
#include <stdlib.h>

#define FIN "arbfind.in"
#define FOUT "arbfind.out"

#define MAX_T 2
#define MAX_N 32001
#define MAX_E 100000

int sons[MAX_T][MAX_N], nodes[MAX_T];
int pos[MAX_T], *T[MAX_T][MAX_N], R[MAX_T], nodes[MAX_T];
int U[MAX_N], et[MAX_T][MAX_E], first[MAX_N];

int read(int t)
{
    int i, n;

    scanf("%d", nodes + t);
    memset(U, 0, sizeof(U));
    for (i = 1; i <= nodes[t]; i++)
    {
        scanf("%d", &sons[t][i]);
        T[t][i] = malloc(sizeof(int) * sons[t][i]);
        for (n = 0; n < sons[t][i]; n++)
        {
            scanf("%d", &T[t][i][n]);
            U[T[t][i][n]] = 1;
        }
    }
    for (i = 1; i <= nodes[t]; i++)
        if (!U[i])
           return i;
}

void euler(int t, int r)
{
    int i;

    et[t][first[r] = pos[t]++] = 1;
    for (i = 0; i < sons[t][r]; i++)
    {
        euler(t, T[t][r][i]);
        et[t][pos[t]++] = 0;
    }
}

int similarity(int p)
{
    int i, cnt = 0, j = 0;

    for (i = p; i < pos[1] && j < pos[0] && et[0][j] == et[1][i]; i++, j++)
        cnt += et[1][i];

    return cnt;
}

int main(void)
{
    int i;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    R[0] = read(0);
    R[1] = read(1);

    pos[0] = 0, euler(0, R[0]);
    pos[1] = 0, euler(1, R[1]);

    for (i = 1; i <= nodes[1]; i++)
        printf("%d\n", similarity(first[i]));

    return 0;
}
