#include <stdio.h>

#define FIN "becuri.in"
#define FOUT "becuri.out"

#define MOD 32U
#define MAX_N 500U
#define MAX_LINE 2000
#define isok(c) ((c) == '0' || (c) == '1')

char line[MAX_LINE];
unsigned G[MAX_N][MAX_N], power[MOD], sum = 0U;
unsigned n, m, M[MAX_N][MAX_N], aux[MAX_N][MAX_N];

void do_zip(void)
{
    unsigned i, j;

    for (i = 0; i < n; i++)
        for (j = 0; j < m; j++)
            aux[i][j] = 0U;
    for (i = 0; i < n; i++)
        for (j = 0; j < m ; j++)
            if (M[i][j])
               aux[i][j / MOD] += power[j % MOD];
}

unsigned solve_lines(unsigned sol)
{
    int ssol = sol, i, j;
    unsigned cnt = 0U, q, s;

    for (i = 0; i < n; i++)
        if (G[i][0] & 1)
        {
            for (j = 0; (j + 1) * MOD < m; j++)
                G[i][j] ^= sum;
            for (j = m - (m % MOD), s = 0U; j < m; j++)
                s += power[j % MOD];
            G[i][j / MOD] ^= s;
        }
    for (i = 1; i < m; i++)
        if (G[0][i / MOD] & power[i % MOD])
           cnt++;
    if (cnt > sol)
       return 0U;

    for (j = 1; j < m; j++)
        if (G[0][j / MOD] & power[j % MOD])
        {
            for (i = 0; i < n; i++)
                G[i][j / MOD] ^= power[j % MOD];
            ssol--;
        }
    for (i = 0; i < n; i++)
        for (j = 0; j < m; j++)
            if (G[i][j / MOD])
               return 0U;
    return ssol ? 0 : 1;
}

unsigned solve_columns(unsigned sol)
{
    unsigned ok = 1, i, j;

    for (i = 0; i < n; i++)
        aux[i][0] ^= 1U;
    for (i = 0; i < n; i++)
        if (aux[i][0] & 1)
        {
            for (j = 0; j < m; j++)
                G[i][j / MOD] ^= power[j % MOD];
            break;
        }
    for (i = 0; i < n; i++)
        for (j = 0; j < m; j++)
            if (G[i][j])
               ok = 0;
    if (!ok)
       return 1U;
    return solve_lines(sol - 1);
}

unsigned solution(unsigned sol)
{
    unsigned cnt = 0, i, j;

    for (i = 0; i < n; i++)
        if (aux[i][0] & 1)
           cnt++;
    if (cnt != sol && cnt != n - sol)
       return 0U;
    for (i = 0; i < n; i++)
        for (j = 0; j < m; j++)
            G[i][j] = aux[i][j];

    if (cnt == sol)
       return solve_lines(sol);
    return solve_columns(sol);
}

int main(void)
{
    char *p;
    unsigned i, j, max_sol, ok = 1;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%u %u\n", &n, &m);
    for (i = 0; i < n; i++)
    {
        fgets(line, MAX_LINE, stdin), p = line;
        for (j = 0; j < m; j++, p++)
        {
            for (; !isok(*p); p++) ;
            M[i][j] = (*p) - '0';
        }
    }
    for (i = 0; i < n; i++)
        for (j = 0; j < m; j++)
            if (M[i][j])
               ok = 0;
    if (ok)
    {
        printf("0\n");
        return 0;
    }
    for (i = 0; i < MOD; i++)
    {
        power[i] = 1U << i;
        sum += power[i];
    }

    do_zip();
    max_sol = n > m ? n : m;
    for (i = 0; i <= max_sol; i++)
        if (solution(i))
        {
            printf("%u\n", i);
            return 0;
        }

    printf("-1\n");

    return 0;
}
