#include <stdio.h>
#include <string.h>

#define FIN "team.in"
#define FOUT "team.out"

#define MAX_P 50
#define MAX_N 500
#define INF 0x3f3f3f3f
#define MIN(a, b) ((a) < (b) ? (a) : (b))

int P, N, D[MAX_P][MAX_N], U[MAX_N];
int G[MAX_N][MAX_N], S[MAX_P], B[MAX_P][MAX_P][MAX_N];

void do_dijkstra(int p)
{
    int i, j, min, pos, tmp;
    const int s = S[p];

    memset(U, 0, sizeof(U));
    for (i = 0; i < N; i++)
        D[p][i] = G[s][i];
    U[s] = 1, D[p][s] = 0;
    for (i = 1; i < N; i++)
    {
        for (j = 0, min = INF; j < N; j++)
            if (D[p][j] < min && !U[j])
               min = D[p][j], pos = j;
        U[pos] = 1, tmp = D[p][pos];
        for (j = 0; j < N; j++)
            if (D[p][j] > tmp + G[pos][j])
               D[p][j] = tmp + G[pos][j];
    }
}

int solve(void)
{
    int i, j, h, l, min;

    for (i = 0; i < P; i++)
        do_dijkstra(i);
    for (i = 0; i < P; i++)
        for (j = 0; j < N; j++)
            B[i][i][j] = D[i][j];
    for (l = 1; l < P; l++)
        for (i = 0; i + l < P; i++)
            for (j = 0; j < N; j++)
            {
                int min = INF;
                const int upp = i + l;
                
                for (h = i; h <= upp; h++)
                {
                    int sum = 0;
                    const int stop = S[h];
                    
                    if (h - 1 >= i)
                       sum += B[i][h - 1][stop];
                    if (h + 1 <= upp)
                       sum += B[h + 1][upp][stop];
                    sum += D[h][j];
                    min = MIN(sum, min);
                }
                B[i][upp][j] = min;
            }

    return B[0][P - 1][0];
}

int main(void)
{
    int i, j, c, M;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d%d%d", &P, &N, &M);
    memset(G, 0x3f, sizeof(G));
    while (M--)
    {
        scanf("%d %d %d", &i, &j, &c);
        i--, j--;
        G[i][j] = G[j][i] = c;
    }
    for (i = 0; i < P; i++)
    {
        scanf("%d", S + i);
        S[i]--;
    }

    printf("%d\n", solve());

    return 0;
}
