#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define FOR(i, a, b) for (i = (a); i <= (b); i ++)
#define REP(i, n)    for (i =   0; i <  (n); i ++)
#define CLEAR(X)     memset((X), 0, sizeof((X)))
#define INF          100000099

#define MIN(a, b) ((a) < (b) ? (a) : (b))

#define NMAX  32005
#define SMAX  131072
#define LGMAX 16

/*
#define NMAX  128
#define SMAX  256
#define LGMAX 10
*/

vector<int> p[NMAX], t[NMAX];
int N, M, i, j, k, stp;
int degin[NMAX];

int a[SMAX], b[SMAX], pa[SMAX], pb[SMAX], suma[SMAX], sumb[SMAX], ak, bk;
int RootA, RootB;

int o[LGMAX][SMAX];
int L;

struct entry{
    int o1, o2, p;
} P[SMAX];

void read(void)
{
    freopen("arbfind.in", "r", stdin);
    freopen("arbfind.out", "w", stdout);
    
    CLEAR(degin);
    scanf("%d", &N);
    FOR(stp, 1, N)
    {
        for (scanf("%d" , &k); k; k --)
            scanf("%d", &i), p[stp].push_back(i), ++ degin[i];
    }
    for (stp = 1; stp <= N; stp ++)
        if (!degin[stp]) RootB = stp;

    CLEAR(degin);
    scanf("%d", &M);
    FOR(stp, 1, M)
    {
        for (scanf("%d" , &k); k; k --)
            scanf("%d", &i), t[stp].push_back(i), ++ degin[i];
    }
    
    for (stp = 1; stp <= M; stp ++)
        if (!degin[stp]) RootA = stp;
}

void dfs_a(int x)   //arborele mare
{
    vector<int> :: iterator it;
    for (it = t[x].begin(); it != t[x].end(); it ++)
    {
        ++ ak, pa[ak] = x, a[ak] = 1;
        dfs_a(*it);
    }
    ++ ak, pa[ak] = x, a[ak] = 0;
}

void dfs_b(int x)   //arborele mic
{
    vector<int> :: iterator it;
    for (it = p[x].begin(); it != p[x].end(); it ++)
    {
        ++ bk, pb[bk] = x, b[bk] = 1;
        dfs_b(*it);
    }
    ++ bk, pb[bk] = x, b[bk] = 0;
}

void solve(void)
{
    ak = bk = 0;
    dfs_a(RootA);
    dfs_b(RootB);

    suma[0] = sumb[0] = 0;
    FOR(i, 1, ak)  suma[i] = suma[i - 1] + a[i];
    FOR(i, 1, bk)  sumb[i] = sumb[i - 1] + b[i];
}

int cmp(struct entry x, struct entry y)
{
    if (x.o1 == y.o1)
        return x.o2 < y.o2 ? 1 : 0;
    else
        return x.o1 < y.o1 ? 1 : 0;
}

int lcp(int x, int y)
{
    int ret = 0, p = stp, len = 1 << stp;
    for (; p >= 0; p --, len >>= 1)
        if (x + len - 1 <= L && y + len - 1 <= L && o[p][x] == o[p][y])
            ret += len, x += len, y += len;
    return ret;
}

void suffix(void)
{
    FOR(i, 1, ak)
        o[0][i] = a[i];
    FOR(i, 1, bk)
        o[0][ak + i] = b[i];
    L = ak + bk;

    int maxLen = MIN(ak, bk);
    int len;
    for (stp = len = 1; 2 * len < maxLen; stp ++, len <<= 1)
    {
        for (i = 1; i <= L; i ++)
            P[i].o1 = o[stp - 1][i], P[i].o2 = (i + len <= L ? o[stp - 1][i + len] : -1), P[i].p = i;
        sort(P + 1, P + L + 1, cmp);

        for (i = 1; i <= L; i ++)
        {
            if (i > 0 && P[i].o1 == P[i - 1].o1 && P[i].o2 == P[i - 1].o2)
                o[stp][ P[i].p ] = o[stp][  P[i - 1].p ];
            else
                o[stp][ P[i].p ] = i;
        }
    }
    -- stp;
}

int used[NMAX], Ans[NMAX];

void bagamarfa(void)
{
    CLEAR(used), CLEAR(Ans);
    FOR(i, 1, ak)
        if (!used[pa[i]])
        {
            used[pa[i]] = 1;
            int ans_len = lcp(i, ak + 1);
            Ans[pa[i]] = 1 + MIN( sumb[ans_len], suma[i + ans_len - 1] - suma[i - 1]);
        }

    FOR(i, 1, M)
        printf("%d\n", Ans[i]);
}

int main(void)
{
    read();
    solve();
    suffix();
    bagamarfa();
    return 0;
}
