using namespace std;

#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

#define FIN  "arbfind.in"
#define FOUT "arbfind.out"

#define MAX_N (1<<15)

int N, M, ans[MAX_N];
vector<int> Gn[MAX_N], Gm[MAX_N];
int vn[MAX_N<<1], vm[MAX_N<<1], cm, cn, start[MAX_N], stop[MAX_N];
int A[MAX_N<<1];

void read()
{
	int i, j, x, cnt;
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d", &N);
	for (i = 1; i <= N; ++i)
		for (fscanf(fi, "%d", &cnt); cnt--; ) {
			fscanf(fi, "%d", &x);
			Gn[i].push_back(x);
		}
	fscanf(fi, "%d", &M);
	for (i = 1; i <= M; ++i)
		for (fscanf(fi, "%d", &cnt); cnt--; ) {
			fscanf(fi, "%d", &x);
			Gm[i].push_back(x);
		}
	fclose(fi);
}

vector<int>::iterator vi[MAX_N];

void DFSn(int n)
{
	vn[++cn] = 0;
	for (vi[n] = Gn[n].begin(); vi[n] != Gn[n].end(); ++vi[n])
		DFSn(*vi[n]);
	vn[++cn] = 1;
}

void DFSm(int n)
{
	vm[ start[n] = ++cm ] = 0;
	for (vi[n] = Gm[n].begin(); vi[n] != Gm[n].end(); ++vi[n])
		DFSm(*vi[n]);
	vm[ stop[n] = ++cm ] = 1;
}

int brute_calc(int n)
{
	int i, j, res;
	for (res = 0, i = 1, j = start[n]; i <= cn && j <= stop[n] &&
		vn[i] == vm[j]; ++i, ++j)
		res += (vn[i] == 0);
	return res;
}

int S[MAX_N<<2], P[MAX_N<<2], R[MAX_N<<2], C[2], ns;
int Bs[MAX_N<<2], idx[19][MAX_N<<2];

void build_sa()
{
	int nb, step, half, i, j;
	C[0] = C[1] = 0;
	for (i = 1; i <= ns; ++i)
		C[ S[i] ]++;
	C[1] += C[0];
	for (i = 1; i <= ns; ++i)
		P[ C[ S[i] ]-- ] = i;
	for (nb = 0, i = 1; i <= ns; ++i) {
		if (i == 1 || S[ P[i] ] != S[ P[i-1] ])
			Bs[++nb] = i;
		idx[0][ P[i] ] = nb;
	}
	for (step = half = 1; nb < ns; ++step, half <<= 1) {
		for (i = 1; i <= ns; ++i)
			if (P[i]+half > ns)
				R[ Bs[ idx[step-1][ P[i] ] ]++ ] = P[i];
		for (i = 1; i <= ns; ++i)
			if (P[i] > half)
				R[ Bs[ idx[step-1][ P[i]-half ] ]++ ] = P[i]-half;
		memcpy(P+1, R+1, ns*sizeof(int));
		for (nb = 0, i = 1; i <= ns; ++i) {
			if (i == 1 || P[i]+half > ns || P[i-1]+half > ns ||
					idx[step-1][P[i]] != idx[step-1][P[i-1]] ||
					idx[step-1][P[i]+half] != idx[step-1][P[i-1]+half])
				Bs[++nb] = i;
			idx[step][P[i]] = nb;
		}
	}
	for (; (1<<step) <= ns; step++)
		memcpy(idx[step]+1, idx[step-1]+1, ns*sizeof(int));
}

int lcp(int x, int y)
{
	int res, step;
	if (x > y)
		x ^= y ^= x ^= y;
	for (step = 0; y+(1<<(step+1))-1 <= ns; ++step);
	for (res = 0; step >= 0; --step)
		if (y+res+(1<<step)-1 <= ns && idx[step][x+res] == idx[step][y+res])
			res += (1<<step);
	return res;
}

int calc(int n)
{
	int pos = start[n]+lcp(start[n], cm+1)-1;
	if (pos > stop[n])
		pos = stop[n];
	if (pos-start[n]+1 > cn)
		pos = start[n]+cn-1;
	return A[pos]-A[start[n]-1];
}

void solve()
{
	int i, j;
	DFSn(1);
	DFSm(1);
	
	if (N <= 2000 && M <= 2000) {
		for (i = 1; i <= M; ++i)
			ans[i] = brute_calc(i);
	} else {
		for (i = 1; i <= cm; ++i)
			S[++ns] = vm[i];
		for (i = 1; i <= cn; ++i)
			S[++ns] = vn[i];

		build_sa();
		for (A[0] = 0, i = 1; i <= cm; ++i)
			A[i] = A[i-1] + (vm[i] == 0);
		for (i = 1; i <= M; ++i)
			ans[i] = calc(i);
	}
}

void write()
{
	int i;
	FILE *fo = fopen(FOUT, "w");
	for (i = 1; i <= M; ++i)
		fprintf(fo, "%d\n", ans[i]);
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
