using namespace std;

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <algorithm>

#define FIN  "becuri.in"
#define FOUT "becuri.out"

#define MAX_N 512

int N, M, A[MAX_N][MAX_N];
int ans;

void read()
{
	int i, j;
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d%d", &N, &M);
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j)
			fscanf(fi, "%d", A[i]+j);
	fclose(fi);
}

int t_eq(int l)
{
	int i;
	for (i = 1; i <= M; ++i)
		if (A[1][i] != A[l][i])
			return 0;
	return 1;
}

int t_neq(int l)
{
	int i;
	for (i = 1; i <= M; ++i)
		if (A[1][i] == A[l][i])
			return 0;
	return 1;
}

void no_sol()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "-1\n");
	fclose(fo);
	exit(0);
}

void test(int l, int c)
{
	if ( (l-c) % 2 != 0 )
		return;
	if (ans == -1 || ans > max(l, c))
		ans = max(l, c);
}

void solve()
{
	int i, j, a, b, _a, _b;
	int al, bl;
	for (al = bl = 0, i = 1; i <= M; ++i)
		if (A[1][i] == A[1][1])
			++al;
		else
			++bl;
	for (a = 1, b = 0, i = 2; i <= N; ++i) {
		if (A[i][1] == A[1][1])
			_a = t_eq(i), _b = 0;
		else
			_a = 0, _b = t_neq(i);
		if (!_a && !_b)
			no_sol();
		a += _a, b += _b;
	}
	ans = -1;
	if (A[1][1] == 0) {
		test(b, bl);
		test(a, al);
	} else {
		test(a, bl);
		test(b, al);
	}
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%d\n", ans);
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
