using namespace std;

#include <cstdio>
#include <cstring>
#include <vector>

#define FIN  "team.in"
#define FOUT "team.out"

#define MAX_P 55
#define MAX_N 505

#define INFTY 0x3f3f3f3f

#define nd first
#define cost second

int P, N, M, des[MAX_N], ok[MAX_N];
int dst[MAX_N][MAX_N];
vector<pair<int, int> > G[MAX_N];

int R[MAX_N];
int T[MAX_P][MAX_P][MAX_P];

void read()
{
	int a, b, c, i;
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d%d%d", &P, &N, &M);
	while (M--) {
		fscanf(fi, "%d%d%d", &a, &b, &c);
		G[a].push_back(make_pair(b, c));
		G[b].push_back(make_pair(a, c));
	}
	for (i = 1; i <= P; ++i)
		fscanf(fi, "%d", des+i);
	fclose(fi);
}

#define QSZ 512

int Q[QSZ], enq[MAX_N], D[MAX_N];

void bkl(int x)
{
	int n, qb, qe;
	vector<pair<int, int> >::iterator it;
	memset(D+1, INFTY, N*sizeof(int));
	D[ Q[qb = qe = 0] = x ] = 0, enq[x] = 1;
	for (; qb <= qe; enq[ Q[(qb++) & 511] ] = 0)
		for (n = Q[qb & 511], it = G[n].begin(); it != G[n].end(); ++it)
			if (D[n]+it->cost < D[it->nd]) {
				D[it->nd] = D[n]+it->cost;
				if (!enq[it->nd])
					enq[ Q[(++qe) & 511] = it->nd ] = 1;
			}
}

int tmp_dst[MAX_N][MAX_N];

void renum()
{
	int i, j, cnt;
	memset(ok, 0, sizeof(ok));
	for (ok[1] = 1, i = 1; i <= P; ++i)
		ok[ des[i] ] = 1;
	for (cnt = 0, i = 1; i <= N; ++i)
		if (ok[i])
			R[i] = ++cnt;
	
	for (i = 1; i <= N; ++i) if (R[i])
		for (j = 1; j <= N; ++j) if (R[j])
			tmp_dst[ R[i] ][ R[j] ] = dst[i][j];
	memcpy(dst, tmp_dst, sizeof(dst));

	for (i = 1; i <= N; ++i)
		des[i] = R[ des[i] ];
	N = cnt;
}

void solve()
{
	int i, j, k, l, x;
	for (i = 1; i <= N; ++i) {
		bkl(i);
		memcpy(dst[i]+1, D+1, N*sizeof(int));
	}
	renum();
	memset(T, INFTY, sizeof(T));
	for (x = 1; x <= N; ++x)
		for (i = 1; i <= P+1; ++i)
			T[x][i][i-1] = 0;
	for (i = 1; i <= P; ++i)
		for (x = 1; x <= N; ++x)
			T[x][i][i] = dst[x][ des[i] ];

	for (l = 1; l < P; ++l)
		for (i = 1, j = i+l; j <= P; ++i, ++j)
			for (x = 1; x <= N; ++x) {
				for (k = i; k <= j; ++k) {
					if (T[x][i][j] > T[des[k]][i][k-1]+T[des[k]][k+1][j]+
							dst[x][des[k]])
						T[x][i][j] = T[des[k]][i][k-1]+T[des[k]][k+1][j]+
							dst[x][des[k]];
				}
			}
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%d\n", T[1][1][P]);
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
