#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 64
#define INF 999999999
#define MIN(a, b) ((a) < (b) ? (a) : (b))

typedef struct t_coada
{
	int l, c;
} coada;

const int dx[4] = {0, -1, 0, 1};
const int dy[4] = {-1, 0, 1, 0};

void read(void);
int bfs(int *l, int *c);

int N, A[MAXN][MAXN], F[MAXN][MAXN], T[MAXN][MAXN], seen[MAXN][MAXN];
coada C[MAXN * MAXN];

int main(void)
{
	int l, c, min = INF, tmpl, tmpc, sl, sc, rez = 0;

	freopen("gard.in", "r", stdin);
    freopen("gard.out", "w", stdout);

    read();

    while (bfs(&l, &c))
    {
    	sl = l, sc = c;
        min = INF;
		while (l > 0 && l < N && c > 0 && c < N)
		{
        	if (A[l][c] != -1)
            	min = MIN(A[l][c] - F[l][c], min);
			tmpl = l, tmpc = c;
            l = tmpl - dx[T[tmpl][tmpc]],
            c = tmpc - dy[T[tmpl][tmpc]];
        }

		l = sl, c = sc;
        while (l > 0 && l < N && c > 0 && c < N)
        {
        	F[l][c] += min;
			tmpl = l, tmpc = c;            
            l = tmpl - dx[T[tmpl][tmpc]],
            c = tmpc - dy[T[tmpl][tmpc]];            
		}
        F[l][c] += min;
		rez += min;
    }

    printf("%d\n", rez);

    return 0;
}

void read(void)
{
	int i, j;

    scanf("%d", &N);
    for (i = 0; i < N; i++)
    	for (j = 0; j < N; j++)
        	scanf("%d", &A[i][j]);
}

int bfs(int *l, int *c)
{
	int b, e, i, k, l2, c2, lin, col;

    memset(seen, 0, sizeof(seen));
	e = -1;
    for (i = 0; i < N; i++)
    {
    	C[++e].l = i, C[e].c = 0,
        C[++e].l = 0, C[e].c = i,
        C[++e].l = N - 1, C[e].c = i,
        C[++e].l = i, C[e].c = N - 1;
	}

	for (b = 0; b <= e; b++)
	{
    	lin = C[b].l, col = C[b].c;
        if (A[lin][col] - F[lin][col] > 0)
        {
        	for (k = 0; k < 4; k++)
            {
            	l2 = lin + dx[k], c2 = col + dy[k];
                if (!seen[l2][c2])
                	seen[l2][c2] = 1, T[l2][c2] = k, C[++e].l = l2, C[e].c = c2;
				if (A[l2][c2] == -1)
                {
                	*l = l2, *c = c2;

                    return 1;
				}
            }
        }
    }

	return 0;
}
