#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <list>
#include <vector>
#include <algorithm>
using namespace std;

#define FOR(i, a, b) for (i = (a); i <= (b); i ++)
#define REP(i, n)    for (i =   0; i <  (n); i ++)
#define FORI(i, x)   for (i = (x).begin(); i != (x).end(); i ++)
#define CLEAR(X)     memset((X), 0, sizeof((X)))
#define pb           push_back
#define mp           make_pair
#define INF          (0x3F3F3F3F)

#define NMAX 38
#define GMAX 6
int a[NMAX][NMAX], m[NMAX][NMAX], w[NMAX][NMAX], inq[NMAX][NMAX];
int N, G, i, j, k, l, Ans;
int x[GMAX], y[GMAX];
list<pair<int, int> > Q;


void read(void)
{
    freopen("gard.in", "r", stdin);
    freopen("gard.out", "w", stdout);
    scanf("%d", &N);
    G = 0;
    FOR(i, 1, N)
        FOR(j, 1, N)
        {
            scanf("%d", &(a[i][j]));
            if (a[i][j] == -1)
                x[G] = i, y[G] = j, ++ G;
        }
}


const int dx[8] = {-1, -1, -1,  0, 0,  1, 1, 1};
const int dy[8] = {-1,  0,  1, -1, 1, -1, 0, 1};
#define GOOD(x, y)  (0 < (x) && 0 < (y) && (x) <= N && (y) <= N)

void min_path(int srcx, int srcy)
{
    memset(w, 0x3F, sizeof(w));
    w[srcx][srcy] = m[srcx][srcy], Q.pb(mp(srcx, srcy));
    CLEAR(inq), inq[srcx][srcy] = 1;

    for (; Q.begin() != Q.end(); Q.pop_front())
    {
        pair<int, int> cur = *(Q.begin());
        int i;
        REP(i, 8)
            if (GOOD(cur.first + dx[i], cur.second + dy[i]) && w[cur.first][cur.second] + m[cur.first + dx[i]][cur.second + dy[i]] < w[cur.first + dx[i]][cur.second + dy[i]])
            {
                w[cur.first + dx[i]][cur.second + dy[i]] = w[cur.first][cur.second] + m[cur.first + dx[i]][cur.second + dy[i]];
                if (!inq[cur.first + dx[i]][cur.second + dy[i]])
                    Q.pb(mp( cur.first + dx[i], cur.second + dy[i] ));
            }

        inq[cur.first][cur.second] = 0;
    }
}

void solve(void)
{
    int stp, i, j, k;
    FOR(i, 1, N) FOR(j, 1, N) if (a[i][j] == -1) a[i][j] = INF;

    REP(k, G)
    {
        int min = 999, max = -999;
        stp = x[k];
        
        FOR(i, 1, N) if (a[stp][i] == INF) { min = i; break; }
        FOR(i, 1, N) if (a[stp][i] == INF) max = i;

        int sus[NMAX], jos[NMAX];
        FOR(i, 1, min - 1)  //pozitia de start
        {
            //deasupra :
            memcpy(m, a, sizeof(a));
            FOR(j, 1, i - 1)   m[stp][j] = INF;
            FOR(j, i + 1, min - 1) m[stp][j] = INF;
            FOR(j, 1, N)       m[stp + 1][j] = INF;

            // jos
            REP(j, G) if (x[j] < stp)
                FOR(l, x[j] + 1, stp - 1)
                    m[l][y[j]] = INF;
            //drum minim
            min_path(stp, i);
            memcpy(sus, w[stp], (N + 1) * sizeof(int));


            //dedesubt:
            memcpy(m, a, sizeof(a));
            FOR(j, 1, i - 1)   m[stp][j] = INF;
            FOR(j, i + 1, min - 1) m[stp][j] = INF;
            FOR(j, 1, N)       m[stp - 1][j] = INF;

            // jos
            REP(j, G) if (x[j] > stp)
                FOR(l, stp + 1, x[j] - 1)
                    m[l][y[j]] = INF;
            //drum minim
            min_path(stp, i);
            memcpy(jos, w[stp], (N + 1) * sizeof(int));

            FOR(j, max + 1, N)
                if (sus[j] + jos[j] - m[stp][i] - m[stp][j] < Ans)
                    Ans = sus[j] + jos[j] - m[stp][i] - m[stp][j];
        }
    }
}


void rot(void)
{
    int aux[NMAX][NMAX], i, j;
    FOR(i, 1, N)
        FOR(j, 1, N)
            aux[i][j] = a[j][i];
    memcpy(a, aux, sizeof(aux));

    REP(i, G)
        x[i] ^= y[i] ^= x[i] ^= y[i];
}

void gen(void)
{
    freopen("gard.in", "w", stdout);
    N = 35;
    int i, j, k;

    FOR(i, 1, N)
        FOR(j, 1, N)
            a[i][j] = rand() % 6666;
    FOR(k, 1, 5)
    {
        do i = 1 + rand() % N, j = 1 + rand() % N; while (a[i][j] == -1);
        a[i][j] = -1;
    }
    printf("%d\n", N);
    FOR(i, 1, N)
    {
        FOR(j, 1, N)
            printf("%d ", a[i][j]);
        printf("\n");
    }
}


int main(void)
{
//    gen();
//    return 0;
    read();

    Ans = INF;
    solve();
    rot();
    solve();

    printf("%d\n", Ans);
    return 0;
}
