using namespace std;

#include <cstdio>
#include <cstring>

#define FIN  "gard.in"
#define FOUT "gard.out"

#define MAX_N 40
#define MAX_K 6

#define INFTY 0x3f3f3f3f

const int dx[] = {-1, -1, 0, +1, +1, +1, 0, -1},
	  dy[] = {0, +1, +1, +1, 0, -1, -1, -1},
	  NDIR = 8;

int N, K, A[MAX_N][MAX_N], ans;
int X[MAX_K], Y[MAX_K];
int xmin, xmax, ymin, ymax;

char S[36][36][36][36];
int cnt[4], vx[4][MAX_N*MAX_N], vy[4][MAX_N*MAX_N];

void read()
{
	int i, j;
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d", &N);
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			fscanf(fi, "%d", A[i]+j);
	fclose(fi);
}

typedef long long ll;

int crossp(int x0, int y0, int x1, int y1, int x2, int y2)
{
	ll t = (ll)(x0-x1)*(ll)(y2-y1) - (ll)(x2-x1)*(ll)(y0-y1);
	return t < 0 ? -1 : t > 0 ? +1 : 0;
}

int intersect(int x0, int y0, int x1, int y1, int x2, int y2, int x3, int y3)
{
	return crossp(x0, y0, x2, y2, x1, y1)*crossp(x0, y0, x3, y3, x1, y1) == -1;
}

#define QSZ 65535

int dst[MAX_N][MAX_N][32], enq[MAX_N][MAX_N][32];
int Qx[QSZ], Qy[QSZ], Qs[QSZ];

inline int onboard(int x, int y)
{
	return x >= 0 && x < N && y >= 0 && y < N && A[x][y] != -1;
}
	
int get_bst(int x, int y)
{
	int qb, qe, px, py, ps, nx, ny, ns, i, j, s;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			for (s = 0; s < (1<<K); ++s) {
				dst[i][j][s] = INFTY;
				enq[i][j][s] = 0;
			}
	dst[x][y][0] = 0, enq[x][y][0] = 1;
	qb = qe = 0;
	Qx[0] = x, Qy[0] = y, Qs[0] = 0;
	
	for (; qb <= qe; ++qb) {
		px = Qx[qb & QSZ], py = Qy[qb & QSZ], ps = Qs[qb & QSZ];
		for (i = 0; i < NDIR; ++i)
			if (onboard(nx = px+dx[i], ny = py+dy[i])) {
				ns = ps ^ S[px][py][nx][ny];
				if (dst[px][py][ps]+A[px][py] <	dst[nx][ny][ns]) {
					dst[nx][ny][ns] = dst[px][py][ps]+A[px][py];
					if (!enq[nx][ny][ns]) {
						++qe;
						Qx[qe & QSZ] = nx;
						Qy[qe & QSZ] = ny;
						Qs[qe & QSZ] = ns;
						enq[nx][ny][ns] = 1;
					}
				}
			}
		enq[px][py][ps] = 0;
	}
	return dst[x][y][(1<<K)-1];
}

void solve()
{
	int i, j, k, l, x, d;
	int minval, pos, tmp;
	
	xmin = ymin = INFTY, xmax = ymax = 0;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			if (A[i][j] == -1) {
				X[K] = i, Y[K++] = j;
				if (i < xmin) xmin = i;
				if (i > xmax) xmax = i;
				if (j < ymin) ymin = j;
				if (j > ymax) ymax = j;
			}
	for (i = 0; i < N; ++i)
	for (j = 0; j < N; ++j) if (A[i][j] != -1)
	for (d = 0; d < NDIR; ++d)
	if (onboard(k = i+dx[d], l = j+dy[d]))
	for (x = 0; x < K; ++x)
	if (Y[x] <= j && Y[x] <= l && intersect(X[x], Y[x], X[x]+1,
		Y[x]+INFTY, i, j, k, l)) {
		S[i][j][k][l] |= (1<<x);
	}
	for (i = 0; i < xmin; ++i)
		for (j = 0; j < N; ++j) {
			vx[0][cnt[0]  ] = i;
			vy[0][cnt[0]++] = j;
		}
	for (i = xmax+1; i < N; ++i)
		for (j = 0; j < N; ++j) {
			vx[1][cnt[1]  ] = i;
			vy[1][cnt[1]++] = j;
		}
	for (i = 0; i < N; ++i)
		for (j = 0; j < ymin; ++j) {
			vx[2][cnt[2]  ] = i;
			vy[2][cnt[2]++] = j;
		}
	for (i = 0; i < N; ++i)
		for (j = ymax+1; j < N; ++j) {
			vx[3][cnt[3]  ] = i;
			vy[3][cnt[3]++] = j;
		}

	for (minval = INFTY, i = 0; i < 4; ++i)
		if (cnt[i] <= minval) {
			minval = cnt[i];
			pos = i;
		}
	for (ans = INFTY, i = 0; i < minval; ++i)
		if (ans > (tmp = get_bst(vx[pos][i], vy[pos][i])))
			ans = tmp;
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%d\n", ans);
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
