// O(N^2)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NMAX 100100
#define INF 666666666

typedef struct values
{
	int min[2][2];
};

int i, j, k, N;
char S[NMAX];

struct values eval(int p1, int p2)
{
	struct values rez1, rez2, rez;
	int i, j, open, found;

	if (p1 >= p2) // S[p1] == 'B'
	{
		rez.min[0][0] = INF;
		rez.min[0][1] = rez.min[1][0] = 1;
		rez.min[1][1] = 2;

		return rez;
	}

	// cauta un 'S'
	open = found = 0;

	for (i = p1; i <= p2; i++)
		if (S[i] == '(')
			open++;
		else
		if (S[i] == ')')
			open--;
		else if (S[i] == 'S' && open == 0)
		{
			found = 1;
			break;
		}

	if (found)
	{
		rez1 = eval(p1, i - 1);
		rez2 = eval(i + 1, p2);

		for (i = 0; i < 2; i++)
			for (j = 0; j < 2; j++)
			{
				rez.min[i][j] = rez1.min[i][0] + rez2.min[0][j];

				if (rez1.min[i][1] + rez2.min[1][j] - 1 < rez.min[i][j])
					rez.min[i][j] = rez1.min[i][1] + rez2.min[1][j] - 1;

				if (rez.min[i][j] > INF)
					rez.min[i][j] = INF;
			}

		/*
		fprintf(stderr, "S");
		for (i = 0; i < 2; i++)
			for (j = 0; j < 2; j++)
				fprintf(stderr, " %d", rez.min[i][j]);
		fprintf(stderr, "\n");
		*/

		return rez;
	}

	// cauta un 'P'
	open = found = 0;

	for (i = p1; i <= p2; i++)
		if (S[i] == '(')
			open++;
		else
		if (S[i] == ')')
			open--;
		else if (S[i] == 'P' && open == 0)
		{
			found = 1;
			break;
		}

	if (found)
	{
		rez1 = eval(p1, i - 1);
		rez2 = eval(i + 1, p2);

		for (i = 0; i < 2; i++)
			for (j = 0; j < 2; j++)
				if (rez1.min[i][j] == INF || rez2.min[i][j] == INF)
					rez.min[i][j] = INF;
				else
					rez.min[i][j] = rez1.min[i][j] + rez2.min[i][j] - (i + j);

		return rez;
	}

	// este o expresie cuprinsa intre paranteze '(' expresie ')'
	return eval(p1 + 1, p2 - 1);
}

int main()
{
	int i, j, T, vmin;
	struct values rez;

	freopen("rsp.in", "r", stdin);
	freopen("rsp.out", "w", stdout);

	scanf("%d ", &T);
	while (T--)
	{
		fgets(S, NMAX - 2, stdin);
		
		N = strlen(S);
		N--;
		if (S[N] == '\n')
			N--;

		rez = eval(0, N);

		vmin = INF;
		for (i = 0; i < 2; i++)
			for (j = 0; j < 2; j++)
				if (rez.min[i][j] < vmin)
					vmin = rez.min[i][j];

		printf("%d\n", vmin);
		fprintf(stderr, "%d\n", vmin);
	}

	return 0;
}
