#include <iostream>
#include <string>
#include <vector>
#include <iterator>

#define K 22
#define maxI 21
#define PRIME 37781

using namespace std;

int mat[K][K];

string transform(const string si)
{
	string so;

	int i = 0;
	while(i < si.size()) {
		if(si[i] != '3') {
			int j = i;
			while(si[i] == si[j] && j < si.size())
				j ++;
			so.push_back((char)(j-i+'0'));
			so.push_back(si[i]);
			i = j;
		} else { 
			so.push_back('1');
			so.push_back('3');
			++ i;
		}
	}

	return so;
}

vector<string> parse(const string &si)
{
	vector<string> result;
	size_t curr = 0, next;

	while((next = si.find('3', curr)) != string::npos) {
		result.push_back(si.substr(curr, next-curr+1));
		curr = next+1;	
	}

	return result;
}

void mul(int (&A)[K][K], const int (&B)[K][K])
{
	int C[K][K];

	for(int i = 0; i < K; ++ i)
		for(int j = 0; j < K; ++ j) {
			int &v = C[i][j];

			v = 0;
			for(int l = 0; l < K; ++ l)
				v = (v + A[i][l]*B[l][j]) % PRIME;
		}

	for(int i = 0; i < K; ++ i)
		for(int j = 0; j < K; ++ j)
			A[i][j] = C[i][j];		
}

int main(void)
{
	vector<string> all;
	string s = "3";

	for(int i = 2; i < maxI; ++ i) {
		string s2 = transform(s);
		// cout << i << " " << s2.size() << endl;

		vector<string> result = parse(s2);
		int count = 0;
		
		for(int j = 0; j < result.size(); ++ j) {
			if(find(all.begin(), all.end(), result[j]) == all.end()) {
				all.push_back(result[j]);
				// cout << " " << result[j];
				count ++;
			}
		}		

		// cout << endl << " [" << count << "/" << all.size() << "]" << endl;
		s = s2;
	}

	sort(all.begin(), all.end());
	assert(all.size() == K);
	
	// cout << "=" << all.size() << endl;
	// copy(all.begin(), all.end(), ostream_iterator<string>(cout, "\n"));

	for(int i = 0; i < K; ++ i) {
		vector<string> result = parse(transform(all[i]));
		for(int j = 0; j < result.size(); ++ j) {
			int p = find(all.begin(), all.end(), result[j]) - all.begin();
			mat[p][i] ++;
		}			
	}

	/*
	for(int i = 0; i < K; ++ i) {
		for(int j = 0; j < K; ++ j)
			cout << mat[i][j] << " ";
		cout << endl;
	}
	*/
	
	freopen("sir.in", "rt", stdin);
	freopen("sir.out", "wt", stdout);

	long long N;
	scanf("%lld", &N);
	N --;

	int A[K][K];
	int R[K][K];

	for(int i = 0; i < K; ++ i)
		for(int j = 0; j < K; ++ j) {
			A[i][j] = mat[i][j];
			R[i][j] = (i == j);
		}			

	while(N) {
		if(N & 1)
			mul(R, A);		

		mul(A, A);
		N >>= 1;
	}

	/*
	for(int i = 0; i < K; ++ i) {
		for(int j = 0; j < K; ++ j)
			cout << R[i][j] << " ";
		cout << endl;
	}
	*/
	
	int sum = 0;
	for(int i = 0; i < K; ++ i)
		sum = (sum + R[i][K-1]*all[i].size()) % PRIME;

	printf("%d\n", sum);

	return 0;
}

